%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                          %
% Middelverdiklassifikator som finner middelverdien for                    %
% refleksjonskoeffisientene                                                %
% fra to datasett. Disse beregnes for R_y                                  %
%                                                                          % 
% Anders Torsteinb, NTNU 2007.                                            % 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
clc;

%Deifinerer True og False variabler. K0=RElav, og K1=REhy
K1True=0;
K1False=0;
K0True=0;
K0False=0;
%Last inn Refleksjonskoeffisient sett Rref og Rtren (Referanse og Trening)
%1. rad i variablene angir om de tilhrer klasse 0 eller klasse 1
load('C:\Documents and Settings\Anders\My Documents\MASTEROPPGAVE\Matlab\ReflK.mat')

[O,antR]=size(Rref);
[O,antT]=size(Rtren);
y=2                     %Setter hvilken R som skal beregnes for. y=2 tilsvarer R_1
avH1=mean(Rref(y,1:256))   %Beregner middelverdikoordinater for begge klassene.
avH2=mean(Rref(y+1,1:256))
avL1=mean(Rref(y,257:512))
avL2=mean(Rref(y+1,257:512))

kovH=cov(Rref(y:y+1,1:256)');   %Beregner kovariansmatrise for begge klassene
kovL=cov(Rref(y:y+1,257:512)');


for k=1:antR                  %Tester ett og ett referansesett
           
       avstandREH=sqrt((Rref(y,k)-avH1)^2+(Rref(y+1,k)-avH2)^2);        %Finner euklidsk avstand mellom to punkter.
       avstandREL=sqrt((Rref(y,k)-avL1)^2+(Rref(y+1,k)-avL2)^2);
 
       %Sjekker om det er treff eller bom og oppdaterer TRUE/FALSE
       %variabler
    if Rref(1,k)==1
        if avstandREH<avstandREL
            K1True=K1True+1;
        else
            K1False=K1False+1;
        end
    else
       if avstandREL<avstandREH
           K0True=K0True+1;
       else
           K0False=K0False+1;
       end
    end
           
    
end

%Lager et plot
figure
hold on;
error_ellipse(kovH, [avH1 avH2], 'style', 'k')      %RE hy presentert i svart farge
error_ellipse(kovL, [avL1 avL2], 'style', 'r')      %RE lav presentert i rd farge

plot(avH1, avH2, 'ko', 'MarkerFaceColor', 'k')
plot(avL1, avL2, 'ro', 'MarkerFaceColor', 'r')

plot(Rtren(y,1:256),Rtren(y+1,1:256),'k.')
plot(Rtren(y,257:512),Rtren(y+1,257:512),'r.')

xlim([-1 1])
ylim([-1 1])

hold off;